# remirepo/Fedora spec file for php-zendframework-zend-navigation
#
# Copyright (c) 2015-2017 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    bcf78525bcfdb7956a516f0a122e5b3fde649d97
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-navigation
%global php_home     %{_datadir}/php
%global library      Navigation
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.8.2
Release:        4%{?dist}
Summary:        Zend Framework %{library} component

Group:          Development/Libraries
License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.5
BuildRequires:  php-pcre
BuildRequires:  php-spl
BuildRequires:  php-autoloader(%{gh_owner}/zend-stdlib)           >= 2.7
# From composer, "require-dev": {
#        "zendframework/zend-config": "^2.6",
#        "zendframework/zend-console": "^2.6",
#        "zendframework/zend-http": "^2.5.4",
#        "zendframework/zend-i18n": "^2.6",
#        "zendframework/zend-log": "^2.7.1",
#        "zendframework/zend-mvc": "^2.7.9 || ^3.0",
#        "zendframework/zend-router": "^3.0",
#        "zendframework/zend-permissions-acl": "^2.6",
#        "zendframework/zend-servicemanager": "^2.7.5 || ^3.0.3",
#        "zendframework/zend-uri": "^2.5",
#        "zendframework/zend-view": "^2.6.5",
#        "phpunit/phpunit": "^4.6",
#        "zendframework/zend-coding-standard": "~1.0.0"
BuildRequires:  php-autoloader(%{gh_owner}/zend-config)           >= 2.6
BuildRequires:  php-autoloader(%{gh_owner}/zend-console)          >= 2.6
BuildRequires:  php-autoloader(%{gh_owner}/zend-http)             >= 2.5.4
BuildRequires:  php-autoloader(%{gh_owner}/zend-i18n)             >= 2.6
BuildRequires:  php-autoloader(%{gh_owner}/zend-log)              >= 2.7.1
BuildRequires:  php-autoloader(%{gh_owner}/zend-mvc)              >= 2.7
BuildRequires:  php-autoloader(%{gh_owner}/zend-router)           >= 3.0
BuildRequires:  php-autoloader(%{gh_owner}/zend-permissions-acl)  >= 2.6
BuildRequires:  php-autoloader(%{gh_owner}/zend-servicemanager)   >= 2.7.5
BuildRequires:  php-autoloader(%{gh_owner}/zend-uri)              >= 2.5
BuildRequires:  php-autoloader(%{gh_owner}/zend-view)             >= 2.6.5
BuildRequires:  php-composer(phpunit/phpunit)                     >= 4.6
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.5 || ^7.0",
#        "zendframework/zend-stdlib": "^2.7 || ^3.0"
Requires:       php(language) >= 5.5
%if ! %{bootstrap}
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)           >= 2.7
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)           <  4
# From composer, "suggest": {
#        "zendframework/zend-config": "^2.6, to provide page configuration (optional, as arrays and Traversables are also allowed)",
#        "zendframework/zend-permissions-acl": "^2.6, to provide ACL-based access restrictions to pages",
#        "zendframework/zend-router": "^3.0, to use router-based URI generation with Mvc pages",
#        "zendframework/zend-servicemanager": "^2.7.5 || ^3.0.3, to use the navigation factories",
#        "zendframework/zend-view": "^2.6.5, to use the navigation view helpers"
%if 0%{?fedora} >= 21
Suggests:       php-autoloader(%{gh_owner}/zend-config)
Suggests:       php-autoloader(%{gh_owner}/zend-permissions-acl)
Suggests:       php-autoloader(%{gh_owner}/zend-servicemanager)
Suggests:       php-autoloader(%{gh_owner}/zend-router)
Suggests:       php-autoloader(%{gh_owner}/zend-view)
%endif
%endif
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 2.6.0
Requires:       php-pcre
Requires:       php-reflection
Requires:       php-spl

Obsoletes:      php-ZendFramework2-%{library} < 2.5
Provides:       php-ZendFramework2-%{library} = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
Zend\Navigation is a component for managing trees of pointers to web pages.
Simply put: It can be used for creating menus, breadcrumbs, links,
and sitemaps, or serve as a model for other navigation related purposes.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Generate autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Stdlib/autoload.php',
]);
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/Zend/Config/autoload.php',
    '%{php_home}/Zend/Permissions/Acl/autoload.php',
    '%{php_home}/Zend/ServiceManager/autoload.php',
    '%{php_home}/Zend/Router/autoload.php',
    '%{php_home}/Zend/View/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/autoload.php';
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Console/autoload.php',
    '%{php_home}/Zend/Http/autoload.php',
    '%{php_home}/Zend/I18n/autoload.php',
    '%{php_home}/Zend/Log/autoload.php',
    '%{php_home}/Zend/Mvc/autoload.php',
    '%{php_home}/Zend/Uri/autoload.php',
]);
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmd in php php56 php70 php71 php72; do
  if which $cmd; then
    $cmd %{_bindir}/phpunit || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}


%changelog
* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 2.8.2-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Wed Dec 13 2017 Remi Collet <remi@remirepo.net> - 2.8.2-3
- switch from zend-loader to fedora/autoloader

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.8.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Thu Mar 23 2017 Remi Collet <remi@remirepo.net> - 2.8.2-1
- Update to 2.8.2

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 2.8.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Tue Jun 14 2016 Remi Collet <remi@fedoraproject.org> - 2.8.1-1
- update to 2.8.1

* Fri Apr  8 2016 Remi Collet <remi@fedoraproject.org> - 2.7.1-1
- update to 2.7.1

* Mon Mar 21 2016 Remi Collet <remi@fedoraproject.org> - 2.6.1-1
- update to 2.6.1

* Thu Feb 25 2016 Remi Collet <remi@fedoraproject.org> - 2.6.0-1
- update to 2.6.0
- raise dependency on PHP >= 5.5
- raise dependency on zend-stdlib >= 2.7

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 2.5.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-1
- initial package